#line 1 "meter.yc"
#include "abcp_.h"

int abc_FieldMeter(abcScanner *s)
{
    int n=0,a;

    s->val.field_M.brace = 0;
    YYSTATE (breve) {
      if (*(abcCursor(s)) == abc_FieldEnd(s)) return 0;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\s+" )
        ":F/F\0\0",
_Y_(  2,"\\\s+%.*" )
        ":Q\134F/F\0Q%/J\0\0",
_Y_(  3,"C|?" )
        ":SC\0-Q|\0\0",
_Y_(  4,"free" )
        ":Sfree\0\0",
_Y_(  5,"none" )
        ":Snone\0\0",
    NULL};
#line 11
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
        case -1 : s->nextstate = S_EOF;
                     return 0;

        case 1 : YYGOTO(breve);

        case 2 : abc_eatSOL(abcStream(s)); YYGOTO(breve);

        case 3 : /* s->val.field_M.num  =0;*/
                     if (YYLEN(0) == 2) {
                       abcMeter(s,isCut) = 1;
                       abcMeter(s,den)   = 2;
                       abcMeter(s,num)   = 2;
                     }
                     else {
                       abcMeter(s,isCommon) = 1;
                       abcMeter(s,den)      = 4;
                       abcMeter(s,num)      = 4;
                     }
                     return 0;

        case 4 :
        case 5 : s->val.field_M.den  =1;
                     s->val.field_M.isFree =1;
                     return 0;
      }} /* abcStream(s */

    }


    YYSTATE (num) {
      if (*(abcCursor(s)) == abc_FieldEnd(s)) return 0;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\s+" )
        ":F/F\0\0",
_Y_(  2,"\+" )
        ":Q+\0",
_Y_(  3,"\\\s+%.*" )
        ":Q\134F/F\0Q%/J\0\0",
_Y_(  4,"\(" )
        ":Q(\0",
_Y_(  5,"\d+" )
        ":D/D\0\0",
_Y_(  6,"\)\s*/?" )
        ":Q)/F\0-Q/\0\0",
_Y_(  7,"/" )
        ":Q/\0",
    NULL};
#line 43
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
        case -1 : s->nextstate = S_EOF;
                     return 0;

        case 1 :
        case 2 : YYGOTO (num);

        case 3 : abc_eatSOL(abcStream(s)); YYGOTO(num);

        case 4 : s->val.field_M.brace = 0x08;
                     YYGOTO (num);

        case 5 : a=atoi(YYSTART(0));
                     if (n<10) s->val.field_M.numAdds[n++] = a;
                     s->val.field_M.num += a;
                     YYGOTO (num);

        case 6 : s->val.field_M.brace |= 0x04;
        case 7 :
                     break;
      }} /* abcStream(s */

    }
    s->val.field_M.den = 1;
    YYSTATE(den) {
      if (*(abcCursor(s)) == abc_FieldEnd(s)) return 0;
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\s+" )
        ":F/F\0\0",
_Y_(  2,"\\\s+%.*" )
        ":Q\134F/F\0Q%/J\0\0",
_Y_(  3,"\(" )
        ":Q(\0",
_Y_(  4,"\d+" )
        ":D/D\0\0",
    NULL};
#line 68
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
        case -1 : s->nextstate = S_EOF;
                     return 0;

        case 1 : YYGOTO(den);

        case 2 : abc_eatSOL(abcStream(s)); YYGOTO(den);

        case 3 : s->val.field_M.brace |= 0x02;
                     YYGOTO(den);

        case 4 : s->val.field_M.den = atoi(YYSTART(0));
                     break;
      }} /* abcStream(s */

    }

    YYSTATE(close) {
      if (*(abcCursor(s)) == abc_FieldEnd(s)) return 0;
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\s+" )
        ":F/F\0\0",
_Y_(  2,"\\\s+%.*" )
        ":Q\134F/F\0Q%/J\0\0",
_Y_(  3,"\)" )
        ":Q)\0",
_Y_(  4,"\s*=\s*(\d+)\s*/\s*(\d+)" )
        ":/F\0Q=/F\0<\1D/D\0>\1/F\0Q//F\0<\2D/D\0>\2\0",
    NULL};
#line 86
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
        case -1 : s->nextstate = S_EOF;
                      return 0;

        case 1 : YYGOTO(close);

        case 2 : abc_eatSOL(abcStream(s)); YYGOTO(close);

        case 3 : s->val.field_M.brace |= 0x01; YYGOTO(close);

        case 4 :
                      s->val.field_M.playNum = atoi(YYSTART(1));
                      s->val.field_M.playDen = atoi(YYSTART(2));
                      YYGOTO(close);
      }} /* abcStream(s */

    }

    return 0;
}
