#line 1 "words.yc"
#include "abcp_.h"


int abcSWords(abcScanner *s)
{
  s->token = T_UNKNOWN;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y%\Y(.*)\|$" )
        ":(Q%(<\1/J\0>\1\42Q\3\0",
_Y_(  2,"\Y\\\y+%\Y(.*)$" )
        ":(Q\134M/M\0Q%(<\1/J\0>\1Q\3\0",
_Y_(  3,"\Y(\d+)[.):]" )
        ":(<\1D/D\0>\1\205\7B\0\4\0",
_Y_(  4,"\Y\n" )
        ":(Q\12\0",
_Y_(  5,"\Y|" )
        ":(Q|\0",
_Y_(  6,"\Y\x2A" )
        ":(Q*\0",
_Y_(  7,"\Y_" )
        ":(Q_\0",
_Y_(  8,"\Y\d+[.):]" )
        ":(D/D\0\205\7B\0\4\0",
_Y_(  9,"\y\Y" )
        ":M(\0",
_Y_( "YYEOL", "" )
        ":Q\3\0",
    NULL};
#line 8
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
      case -1 : s->nextstate = S_EOF;
                         abc_SetEmptyToken(s,T_EOF);
                         return 0;

      case 1 : abc_SetToken(s,T_COMMENT);
                         abcComment(s,string) =YYSTART(1);
                         abcComment(s,string_len) = YYLEN(1);
                            return 0;

      case 2 :
                         abc_SetToken(s,T_LYR_CONTINUE);
                         abcComment(s,string)=YYSTART(1);
                         abcComment(s,string_len)=YYLEN(1);
                         s->nextstate=S_EATSOL;
                         return 0;

      case 3 :
                         abc_SetToken(s,T_LYR_VERSE);
                         abcLyrics(s,verse)=atoi(YYSTART(1));
                         return 0;

      case 4 : abc_SetToken(s,T_CONTINUE);
                         return 0;

      case 5 : abc_SetToken(s,T_LYR_BAR);
                         return 0;

      case 6 : abc_SetToken(s,T_LYR_BLANK);
                         return 0;

      case 7 : abc_SetToken(s,T_LYR_HOLD);
                         return 0;

      case 8 : abc_SetToken(s,T_LYR_VERSE);
                         abcLyrics(s,verse) = atoi(YYSTART(0));
                         return 0;

      case 9 : abc_SetToken(s,T_LYR_SPACE);
                         abcLyrics(s,spaces)=YYLEN(0);
                         return 0;

      case 10 : s->nextstate = S_TUNE;
                         abc_SetEmptyToken(s,T_ENDLINE);
                         return 0;


  }} /* abcStream(s */


  s->tokstart = abcCursor(s);
  s->toklen   = 0;
  s->token    = T_LYR_SYLLABLE;

  YYSTATE (syllable) {
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\\." )
        ":Q\134J\0",
_Y_(  2,"[^\03\y\d\*_-]" )
        ":\200\353\10\367\375\377\377\376\333\377\377\377\377\377\177\0",
_Y_(  3,"]" )
        ":Q]\0",
_Y_(  4,"-" )
        ":Q-\0",
    NULL};
#line 62
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

      case -1 : s->nextstate = S_EOF;
                         YYGOTO(done);

      case 1 :
      case 2 : break;

      case 3 : if ((s->state & 0xFF00) == S_INFIELD) {
                           s->nextstate = S_TUNE;
                           YYGOTO(done);
                         }
                         break;

      case 4 :
      default          : YYGOTO(done);

    }} /* abcStream(s */

    s->toklen++;
    YYGOTO(syllable);
  }

  YYSTATE (done) {
    abcLyrics(s,syllable)=abcTokenStart(s);
    abcLyrics(s,syllable_len)=abcTokenLen(s);
  }
  return 0;
}
